var browserIE = false;
var pmjsButtons = new Array();

function pmjsEventLogTab(device) {
   var html = '';
   
   html += '<div class="label" id="eventLogStatus" style="position: absolute; top: 22px; left: 22px;"></div><div class="button" id="eventLogButton" style="position: absolute; top: 15px; left: 20px; width: 150px; height: 20px;" onclick="pmjsGetEventLog('+device+');">Update Event Log</div>';
   html += '<div class="label" id="eventLogInput" style="position: absolute; top: 18px; left: 210px; width: 200px; height: 20px;">Access Code: <input type="password" name="pinTextArea" id="pinTextArea" maxlength="4" size="4"></div>';
   html += '<textarea readonly="yes" cols="70" rows="17" id="eventLogTextArea" style="resize: none; position: absolute; top: 50px; left: 22px;"></textarea>';

   pmjsDetectBrowser();
   set_panel_html(html);
   var mode = get_device_state(device, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "PowerlinkMode", 1);
   if (mode == 'Powerlink') {
      document.getElementById('eventLogInput').style.visibility = 'hidden';
   }
   pmjsUpdateEventLog(device);
}

function pmjsUpdateEventLog(device) {
   var eventLog = get_device_state(device, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "EventLog", 1);
   if (eventLog == '') {
      setTimeout("pmjsUpdateEventLog("+device+")", 1000);
   } else {
      eventLog = "Time                   User       Event\r\n" + eventLog;
      document.getElementById('eventLogTextArea').value = eventLog;
      document.getElementById('eventLogStatus').innerHTML = '';
      document.getElementById('eventLogButton').style.visibility = 'visible';
   }
};

function pmjsGetEventLog(device) {
   var pin = document.getElementById('pinTextArea').value;
   call_action(device, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", 'GetEventLog', {'PINCode': pin} );
   document.getElementById('eventLogButton').style.visibility = 'hidden';
   document.getElementById('eventLogStatus').innerHTML = '<blink>Retrieving information...</blink>';
   setTimeout("pmjsUpdateEventLog("+device+")", 2000);
};


function pmjsCanEditZones(deviceID) {
   var powerlink = (get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "PowerlinkMode", 1) == 'Powerlink');
   var autoCreate = (get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "AutoCreate", 0) == '1');
   var forceStandard = (get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "ForceStandard", 0) == '1');
   
   return (powerlink == false) || (forceStandard == true) || (autoCreate == false);
}

function pmjsZonesTab(deviceID) {
   var html = '';
   var canEdit = pmjsCanEditZones(deviceID);
   var extra = '';
   var dynamic;
   if (canEdit == false) {
      extra = ' disabled';
      dynamic = 1
   } else {
      dynamic = 0
   }
   var doorZones = get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "DoorZones", dynamic);
   var motionZones = get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "MotionZones", dynamic);
   var smokeZones = get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "SmokeZones", dynamic);
   html += '<style type="text/css">td {text-align:center; vertical-align:middle;} .skinned-form-controls input[type="radio"]:disabled + span { opacity: 0.5; }</style>';
   html += '<table class="skinned-form-controls skinned-form-controls-mac" width="100%" border="0" cellspacing="2" cellpadding="0">';
   html += '</tr>';
   var zhtml = ['', '', '', '', '', '', '', '', '', ''];
   for (var i = 1; i <= 30; i++) {
      var row = (i - (i % 16)) / 16;
      zhtml[0 + 5 * row] += '<td>' + i + '</td>';
      zhtml[1 + 5 * row] += '<td><input type="radio" id="Z' + i + '_door" name="Z' + i + '" value="door" onChange="pmjsUpdateZones(' + deviceID + ')"'+extra+'><span></span></td>';
      zhtml[2 + 5 * row] += '<td><input type="radio" id="Z' + i + '_motion" name="Z' + i + '" value="motion" onChange="pmjsUpdateZones(' + deviceID + ')"'+extra+'><span></span></td>';
      zhtml[3 + 5 * row] += '<td><input type="radio" id="Z' + i + '_smoke" name="Z' + i + '" value="smoke" onChange="pmjsUpdateZones(' + deviceID + ')"'+extra+'><span></span></td>';
      zhtml[4 + 5 * row] += '<td><input type="radio" id="Z' + i + '_none" name="Z' + i + '" value="none" onChange="pmjsUpdateZones(' + deviceID + ')"'+extra+'><span></span></td>';
   }
   for (var i = 0; i <= 1; i++) {
      html += '<tr><td colspan="16" style="text-align:left;"><b>Zone configuration ' + (15*i+1) + '-' + (15*(i+1)) + '</td></tr>';
      html += '<tr><td></td>' + zhtml[0 + 5 * i] + '</tr>';
      html += '<tr><td style="text-align:left;">Door/window</td>' + zhtml[1 + 5 * i] + '</tr>';
      html += '<tr><td style="text-align:left;">Motion</td>' + zhtml[2 + 5 * i] + '</tr>';
      html += '<tr><td style="text-align:left;">Smoke/gas</td>' + zhtml[3 + 5 * i] + '</tr>';
      html += '<tr><td style="text-align:left;">Not used</td>' + zhtml[4 + 5 * i] + '</tr>';
      html += '<tr><td colspan="16" style="padding-top:15px;"></td></tr>';
   }
   if (canEdit == false) {
      html += '<tr><td style="text-align:left; padding-top:5px;" colspan="16"><i>Note: Zones cannot be edited since the "Auto-create devices" option is On (see tab "Settings").</i></td></tr>'
   }
   html += '</table>';
   set_panel_html(html);

   for (var i = 1; i <= 30; i++) {
      var value;
      var name = 'Z' + i
      if (i < 10) {
         name = 'Z0' + i
      } 
      if (doorZones.indexOf(name) >= 0) {
         document.getElementById('Z'+i+'_door').checked = true;
      } else
      if (motionZones.indexOf(name) >= 0) {
         document.getElementById('Z'+i+'_motion').checked = true;
      } else
      if (smokeZones.indexOf(name) >= 0) {
         document.getElementById('Z'+i+'_smoke').checked = true;
      } else {
         document.getElementById('Z'+i+'_none').checked = true;
      }
   }
}

function pmjsUpdateZones(deviceID) {
   var doorZones = '';
   var motionZones = '';
   var smokeZones = '';
   for (var i = 1; i <= 30; i++) {
      var value;
      var name = 'Z' + i
      if (i < 10) {
         name = 'Z0' + i
      } 
      if (document.getElementById('Z'+i+'_door').checked == true) {
         doorZones += ',' + name;
      } else
      if (document.getElementById('Z'+i+'_motion').checked == true) {
         motionZones += ',' + name;
      } else
      if (document.getElementById('Z'+i+'_smoke').checked == true) {
         smokeZones += ',' + name;
      }
   }
   set_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "DoorZones", doorZones.substr(1), 0);
   set_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "MotionZones", motionZones.substr(1), 0);
   set_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "SmokeZones", smokeZones.substr(1), 0);
}

function pmjsDevicesTab(deviceID) {
   var html = '';
   var canEdit = pmjsCanEditZones(deviceID);
   var extra = '';
   var dynamic;
   if (canEdit == false) {
      extra = ' disabled';
      dynamic = 1
   } else {
      dynamic = 0
   }
   var devices = get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "Devices", dynamic);
   
   html += '<style type="text/css">td {text-align:center; vertical-align:middle;} input {margin:0px;} .skinned-form-controls input[type="checkbox"]:disabled + span { opacity: 0.7; }</style>';
   html += '<table class="skinned-form-controls skinned-form-controls-mac" width="100%" border="0" cellspacing="5" cellpadding="0">';
   html += '<tr><td style="text-align:left;" colspan="16"><b>Device configuration</td></tr><tr><td></td>';
   for (var i = 1; i <= 15; i++) {
      html += '<td>' + i + '</td>';
   }
   html += '</tr><tr><td style="text-align:left;">PGM</td><td><input type="checkbox" id="PGM" name="PGM" value="pgm" onChange="pmjsUpdateDevices(' + deviceID + ')"'+extra+'><span></span></td>';
   html += '</tr><tr><td style="text-align:left;">X-10</td>';
   for (var i = 1; i <= 15; i++) {
      html += '<td><input type="checkbox" id="X'+i+'_x10" name="X'+i+'" value="x10" onChange="pmjsUpdateDevices(' + deviceID + ')"'+extra+'><span></span></td>';
   }
   html += '</tr><tr><td style="text-align:left;">X-10 dimmable</td>';
   for (var i = 1; i <= 15; i++) {
      html += '<td><input type="checkbox" id="X'+i+'_dim" name="X'+i+'" value="dim" onChange="pmjsUpdateDevices(' + deviceID + ')"><span></span></td>';
   }
   html += '</tr><tr><td style="text-align:left;">Keypad (1-way)</td>';
   for (var i = 1; i <= 2; i++) {
      html += '<td><input type="checkbox" id="K1'+i+'_key" name="K1'+i+'" value="key" onChange="pmjsUpdateDevices(' + deviceID + ')"'+extra+'><span></span></td>';
   }
   html += '</tr><tr><td style="text-align:left;">Keypad (2-way)</td>';
   for (var i = 1; i <= 8; i++) {
      html += '<td><input type="checkbox" id="K2'+i+'_key" name="K2'+i+'" value="key" onChange="pmjsUpdateDevices(' + deviceID + ')"'+extra+'><span></span></td>';
   }
   html += '</tr><tr><td style="text-align:left;">Siren</td>';
   for (var i = 1; i <= 2; i++) {
      html += '<td><input type="checkbox" id="S'+i+'_siren" name="S'+i+'" value="siren" onChange="pmjsUpdateDevices(' + deviceID + ')"'+extra+'><span></span></td>';
   }
   html +='</tr>';
   if (canEdit == false) {
      html += '<tr><td style="text-align:left; padding-top:25px;" colspan="16"><i>Note: Devices cannot be edited since the "Auto-create devices" option is On (see tab "Settings").</i></td></tr>'
   }
   html += '</table>';
   set_panel_html(html);

   for (var i = 1; i <= 2; i++) {
      if (devices.indexOf('K1'+i) >= 0) {
         document.getElementById('K1'+i+'_key').checked = true;
      }
      if (devices.indexOf('S0'+i) >= 0) {
         document.getElementById('S'+i+'_siren').checked = true;
      }
   }
   for (var i = 1; i <= 8; i++) {
      if (devices.indexOf('K2'+i) >= 0) {
         document.getElementById('K2'+i+'_key').checked = true;
      }
   }
   for (var i = 1; i <= 15; i++) {
      var name = 'X' + i
      if (i < 10) {
         name = 'X0' + i
      } 
      if (devices.indexOf(name) >= 0) {
         document.getElementById('X'+i+'_x10').checked = true;
      } else {
         document.getElementById('X'+i+'_dim').disabled = true;
      }
      if (devices.indexOf(name + 'd') >= 0) {
         document.getElementById('X'+i+'_dim').checked = true;
      }
   }
   if (devices.indexOf('PGM') >= 0) {
      document.getElementById('PGM').checked = true;
   }
}

function pmjsUpdateDevices(deviceID) {
   var devices = '';
   for (var i = 1; i <= 2; i++) {
      if (document.getElementById('K1'+i+'_key').checked == true) {
         devices += ',K1' + i;
      }
      if (document.getElementById('S'+i+'_siren').checked == true) {
         devices += ',S0' + i;
      }
   }
   for (var i = 1; i <= 8; i++) {
      if (document.getElementById('K2'+i+'_key').checked == true) {
         devices += ',K2' + i;
      }
   }
   for (var i = 1; i <= 15; i++) {
      if (document.getElementById('X'+i+'_x10').checked == true) {
         var name = 'X' + i;
         if (i < 10) {
            name = 'X0' + i;
         }
         document.getElementById('X'+i+'_dim').disabled = false;
         if (document.getElementById('X'+i+'_dim').checked == true) {
            name = name + 'd';
         }
         devices += ',' + name;
      } else {
         document.getElementById('X'+i+'_dim').disabled = true;
         document.getElementById('X'+i+'_dim').checked = false;
      }
   }
   if (document.getElementById('PGM').checked == true) {
         devices += ',PGM';
   }
   set_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", "Devices", devices.substr(1), 0);
}

function pmjsSettingsTab(deviceID) {
   var deviceObj = get_device_obj(deviceID);
   var html = '';
   html += '<table width="70%" border="0" cellspacing="5" cellpadding="0">';
   html += '<tr><td colspan="3"><div class="label"><b>General options</b></div></td></tr>';
   
   if (deviceObj.commUse) {
      html += '<tr>';
      html += ' <td width="200">Communicate using UART</td>';
      html += ' <td>' + CommProv_pulldown(deviceID) + '</td>';
      html += '</tr>';
   }
   var timeouts = [{'value':'1','label':'1 minute'}, {'value':'2','label':'2 minutes'}, {'value':'3','label':'3 minutes'}, {'value':'4','label':'4 minutes'}, {'value':'5','label':'5 minutes'}];
   var languages = [{'value':'EN','label':'English'}, {'value':'NL','label':'Nederlands'}];
   var remotearm = [{'value':'false','label':'No arm/disarm allowed'}, {'value':'arm','label':'Only arm away allowed'}, {'value':'stay','label':'Arm (Home) allowed'}, {'value':'disarm','label':'Arm & disarm allowed'}];
   var sensorarm = [{'value':'auto','label':'Defined by panel'}, {'value':'bypass','label':'Always show bypass'}, {'value':'live','label':'Always show armed live'}];

   html += pmjsAddPulldown(deviceID, 'Motion sensor timeout', 'MotionOffDelay', timeouts);
   html += pmjsAddPulldown(deviceID, 'Language selection', 'PluginLanguage', languages);
   html += pmjsAddButtons(deviceID, 'Generate debug logging & files', 'PluginDebug');
   html += '<tr><td colspan="3"><div class="label"><b>Powerlink options</b></div></td></tr>';
   html += pmjsAddButtons(deviceID, 'Force Standard mode', 'ForceStandard');
   html += pmjsAddButtons(deviceID, 'Auto-create devices', 'AutoCreate');
   html += pmjsAddButtons(deviceID, 'Auto-sync time on startup', 'AutoSyncTime');
   html += pmjsAddPulldown(deviceID, 'Allow (dis-)arm without PIN', 'EnableRemoteArm', remotearm);
   html += pmjsAddPulldown(deviceID, 'Sensor arm status', 'SensorArm', sensorarm);
   html += '</table>';

   set_panel_html(html);
   pmjsSettingsButtons(deviceID);
}

function pmjsSettingsButtons(deviceID) {
   var dataLen = pmjsButtons.length;
   for (var i = 0; i < dataLen; i++) {
      var state = get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", pmjsButtons[i], 0)
      if (state == "1") {
         document.getElementById(pmjsButtons[i] + 'On').className = "button selected";
         document.getElementById(pmjsButtons[i] + 'Off').className = "button";
      } else {
         document.getElementById(pmjsButtons[i] + 'Off').className = "button selected";
         document.getElementById(pmjsButtons[i] + 'On').className = "button";
      }
   }
}

function pmjsUpdate(deviceID, variable, value) {
   set_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", variable, value, 0);
   pmjsSettingsButtons(deviceID);
}

function pmjsAddPulldown(deviceID, label, variable, values) {
   var selected = get_device_state(deviceID, "urn:micasaverde-com:serviceId:PowermaxAlarmPanel1", variable, 0);
   var pulldown = pulldown_from_array(values, variable + 'Select', selected, 'onChange="pmjsUpdate(' + deviceID + ', \'' + variable + '\', this.value)"');
   var html = '<tr><td><div class="label">' + label + '</div></td><td colspan="2">' + pulldown + '</td></tr>';

   return html;
}

function pmjsAddButtons(deviceID, label, variable) {
   var html = '<tr><td><div class="label">' + label + '</div></td><td><div class="button" id="' + variable + 'Off" onclick="pmjsUpdate(' + deviceID + ', \'' 
            + variable + '\', \'0\')">Off</div></td><td><div class="button" id="' + variable + 'On" onclick="pmjsUpdate(' + deviceID + ', \'' 
            + variable + '\', \'1\')">On</div></tr></td>';
   pmjsButtons.push(variable);
   
   return html;
}

function pmjsDetectBrowser() {
   var place = navigator.userAgent.toLowerCase().indexOf('msie');
   browserIE = (place != -1)
}

// Taken from Sonos plugin - thanks lolodomo
function call_action(device, sid, actname, args) {
   var q = {
      'id': 'lu_action',
      'output_format': 'xml',
      'DeviceNum': device,
      'serviceId': sid,
      'action': actname
   };
   var key, count = 0;
   for (key in args) {
      count++;
   }
   if (count > 0) {
      Object.extend(q, args);
   }
   if (browserIE) {
      Object.extend(q, {timestamp: new Date().getTime()}); //we need this to avoid IE caching of the AJAX get
   }
   new Ajax.Request (command_url+'/data_request', {
      method: 'get',
      parameters: q,
      onSuccess: function (response) {
      },
      onFailure: function (response) {
      },
      onComplete: function (response) {
      }
   });
}